#include "../SDK/foobar2000.h"
#include "../helpers/helpers.h"
#include <windows.h>

/**************************
Providing information about a component.

We can provide some information about our component that 
users will be able to view under Preferences->Components.
**************************/


DECLARE_COMPONENT_VERSION(
	// component name
	"SkipBad",
	// component version
	"1.0",
	"Skips bad tracks\n"
	"\n"
	"by GDR!\n"
	"http://gdr.prv.pl/\n"
	"Based on Holger Stenger's tutorial, thanks a lot!")

int last_reason = 0;	// Last stop reason

class initquit_skipbad : public initquit {
	virtual void on_init() {
	}

	virtual void on_quit() {
	}
};

// We have to use a service factory to make our callback known to
// the system. Service factories have to be statically created.
static initquit_factory< initquit_skipbad > foo_initquit;

class play_callback_skipbad : public play_callback {
public:
	virtual unsigned get_callback_mask() {
		return MASK_on_playback_stop;
	}

	virtual void on_playback_stop(play_control::stop_reason reason) {
		if(last_reason == 2 && reason == 1) //play_control::STOP_REASON_STARTING_ANOTHER && reason == play_control::STOP_REASON_EOF)
		{
			/* We've got a failure... possibly */
			play_control * pc = play_control::get();
			metadb_handle * handle = pc->get_now_playing();
			if(!handle) 
			{
				/* This is a failure for sure! */
				pc->play_start(pc->track_command::TRACK_COMMAND_NEXT);
			}
		}
		else
		{
			last_reason = reason;
		}

	}

	// We don't use those...
	virtual void on_playback_new_track(metadb_handle * track) {	}
	virtual void on_playback_starting() {}
	virtual void on_playback_seek(double time) {}
	virtual void on_playback_pause(int state) {}
	virtual void on_playback_edited(metadb_handle * track) {}
	virtual void on_playback_dynamic_info(const file_info * info,bool b_track_change) {}
	virtual void on_playback_time(metadb_handle * track, double val) {}
	virtual void on_volume_change(int new_val) {}
};

// Here we go again: another service factory for another callback.
static play_callback_factory< play_callback_skipbad > foo_play_callback;

